package linkMRM.L2;

import java.awt.Color;

import GenCol.entity;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class RetransmissionModule extends ViewableAtomic{
	
	protected double delay;
	
	public RetransmissionModule() {this("Retransmission Module", .1);}
	public RetransmissionModule(String name, double delay){
		super(name);

		addInport("confirmation");
		addOutport("send");
		addOutport("ack");

		this.delay = delay;
		
		this.backgroundColor = Color.YELLOW;

	}
	
	public void deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "confirmation", i)){
				entity checksum = x.getValOnPort("confirmation", i);
				if(checksum.eq("ack"))
					holdIn("approve", delay);
				else if(checksum.eq("nack")) 
					holdIn("reject", delay);
			}
		}
	}
	
	public void deltint(){
		passivate();
	}
	
	public message out(){
		message msg = new message();
		if(phaseIs("approve")){
			msg.add(makeContent("ack", new entity("ack")));
		}
		else if(phaseIs("reject")){
			msg.add(makeContent("send", new Signal(1)));
		}
		return msg;
	}
}
