package linkMRM.L3;

import java.awt.Color;

import GenCol.entity;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class RetransmissionModule extends ViewableAtomic{

	protected double delay;
	protected int erroneousWire;

	public RetransmissionModule() {this("Retransmission Module", .1);}
	public RetransmissionModule(String name, double delay){
		super(name);

		addInport("confirmation");
		addOutport("send");

		this.delay = delay;
		this.backgroundColor = Color.YELLOW;

	}

	public void deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "confirmation", i)){
				entity checksum = x.getValOnPort("confirmation", i);
				if(!checksum.eq("ack")){
					erroneousWire = Integer.parseInt(checksum.getName());
					holdIn("reject", delay);
				}
			}
		}
	}

	public void deltint(){
		passivate();
	}

	public message out(){
		message msg = new message();
		if(phaseIs("reject")){
			msg.add(makeContent("send", new entity("send")));
		}
		return msg;
	}
}
