package linkMRM.L3;

import java.awt.Color;

import GenCol.entity;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class Wire extends ViewableAtomic{
	protected double wireDelay;
	protected int travellingBit;
	
	public Wire(String name) {this(name, Config.channelDelay);}
	public Wire(String name, double delay){
		super(name);

		addInport("wireIn");
		addOutport("wireOut");

		this.wireDelay = delay;
		this.backgroundColor = Color.green;
	}

	/*initialization*/
	public void initialize( ){
		phase = "passive";
		sigma = INFINITY;
		super.initialize( );
	}

	/*External Transition Function*/
	public void  deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "wireIn", i)){
				travellingBit = Integer.parseInt((x.getValOnPort("wireIn", i)).getName());
				holdIn("active", this.wireDelay);
			}
		}
	}

	/*Internal Transition Function*/
	public void  deltint( ){
		if(phaseIs("active")){
			passivate();
		}
	}

	/*Output Function*/
	public message out(){
		message m = new message();
		if ((phaseIs("active"))){	  
			m.add(makeContent("wireOut", new entity(Integer.toString(travellingBit))));
		}  
		return m;
	}
}
