package linkMRM.L2;

import java.awt.Color;

import linkMRM.flitSuper;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class OutputModule extends ViewableAtomic{

	protected double delay;
	protected flitSuper travellingFlit;

	public OutputModule() {this("Output Module", .1);}
	public OutputModule(String name, double delay){
		super(name);

		addInport("channelOutput");
		addInport("confirmation");
		addOutport("linkOut");

		this.delay = delay;
		
		this.backgroundColor = Color.ORANGE;

	}

	public void deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "channelOutput", i)){
				travellingFlit = (flitSuper) (x.getValOnPort("channelOutput", i));
			}
			else if(messageOnPort(x, "confirmation", i)){
				if((x.getValOnPort("confirmation", i)).eq("ack"))
					holdIn("output", delay);
			}
		}
	}

	public void deltint(){
		passivate();
	}
	
	public message out(){
		message msg = new message();
		if(phaseIs("output")){
			msg.add(makeContent("linkOut", travellingFlit));
		}
		return msg;
	}
	
}
