package linkMRM.L3;

import java.awt.Color;

import GenCol.entity;
import linkMRM.flitSuper;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class OutputModule extends ViewableAtomic{

	protected double delay;
	protected flitSuper travellingFlit;

	public OutputModule() {this("Output Module", Config.outBufferDelay);}
	public OutputModule(String name, double delay){
		super(name);

		addInport("channelOutput");
		addInport("confirmation");
		addOutport("linkOut");
		addOutport("ack");

		this.delay = delay;
		this.backgroundColor = Color.ORANGE;

	}
	
	/*initialization*/
	public void initialize( ){
		phase = "passive";
		sigma = this.delay;
		super.initialize( );
	}

	public void deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "channelOutput", i)){
				travellingFlit = (flitSuper) (x.getValOnPort("channelOutput", i));
				phase = "passive";
			}
			else if(messageOnPort(x, "confirmation", i)){
				if((x.getValOnPort("confirmation", i)).eq("ack"))
					phase = "output";
			}
		}
	}

	public void deltint(){
		holdIn("passive", this.delay);
	}
	
	public message out(){
		message msg = new message();
		if(phaseIs("output")){
			msg.add(makeContent("linkOut", travellingFlit));
			msg.add(makeContent("ack", new entity("ack")));
		}
		return msg;
	}
	
}
